﻿Imports System.Windows.Forms

Public Class dlgMyPageSetupDialog

    Private _pagesettings As MyPageSettings
    Private _printersettings As Printing.PrinterSettings
    Private _EnableMetric As Boolean
    Private _PreviewText As String = _
        "Dies ein Test für die Seiteneinstellungen ihres Druckers." & _
        vbCrLf & "Doch manchmal ist einfach zu blöd einen sinnvollen Text " & _
        "für sowas zu erstellen daher lassen wird das jetzt und geben den " & _
        "Text einfach mal aus." & vbCrLf & vbCrLf

    Public Property PageSettings() As MyPageSettings
        Get
            Return _pagesettings
        End Get
        Set(ByVal value As MyPageSettings)
            _pagesettings = value
            _printersettings = _pagesettings.PrinterSettings
        End Set
    End Property

    Public Property PrinterSettings() As Printing.PrinterSettings
        Get
            Return _printersettings
        End Get
        Set(ByVal value As Printing.PrinterSettings)
            _printersettings = value
        End Set
    End Property

    Public Property EnableMetric() As Boolean
        Get
            Return _EnableMetric
        End Get
        Set(ByVal value As Boolean)
            _enableMetric = value
        End Set
    End Property

    Private Sub btnOk_Click(ByVal sender As System.Object, _
                            ByVal e As System.EventArgs) Handles btnOk.Click
        CreateNewPageSettings()
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, _
                                ByVal e As System.EventArgs) _
                            Handles btnCancel.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub btnPrinter_Click(ByVal sender As System.Object, _
                                 ByVal e As System.EventArgs) _
                             Handles btnPrinter.Click
        Dim dlgprn As New dlgMyPrinterSettings
        dlgprn.PrinterSettings = _printersettings
        If dlgprn.ShowDialog = Windows.Forms.DialogResult.OK Then
            _printersettings = dlgprn.PrinterSettings
            _pagesettings = New MyPageSettings(_printersettings)
            ShowPageSettings()
        End If
    End Sub

    Private Sub ShowPageSettings()
        pnlPreview.SuspendLayout()
        cbxPaperSize.Items.Clear()
        For Each ps As Printing.PaperSize In _
                _pagesettings.PrinterSettings.PaperSizes
            cbxPaperSize.Items.Add(ps.PaperName)
        Next
        cbxPaperSize.SelectedItem = _pagesettings.PaperSize.PaperName
        cbxPaperSource.Items.Clear()
        If _printersettings.PaperSources.Count > 0 Then
            For Each ps As Printing.PaperSource In _printersettings.PaperSources
                cbxPaperSource.Items.Add(ps.SourceName)
            Next
            cbxPaperSource.SelectedItem = _pagesettings.PaperSource.SourceName
            cbxPaperSource.Enabled = True
        Else
            cbxPaperSource.Enabled = False
        End If
        If _pagesettings.Landscape Then
            rbtLandscape.Checked = True
        Else
            rbtNormal.Checked = True
        End If
        If Globalization.RegionInfo.CurrentRegion.IsMetric And _EnableMetric Then
            txtMarginLeft.Text = Math.Round( _
                _pagesettings.Margins.LeftMetric / 10, 2).ToString
            txtMarginRight.Text = Math.Round( _
                _pagesettings.Margins.RightMetric / 10, 2).ToString
            txtMarginTop.Text = Math.Round( _
                _pagesettings.Margins.TopMetric / 10, 2).ToString
            txtMarginBottom.Text = Math.Round( _
                _pagesettings.Margins.BottomMetric / 10, 2).ToString
        Else
            txtMarginLeft.Text = Math.Round( _
                _pagesettings.Margins.Left / 10, 2).ToString
            txtMarginRight.Text = Math.Round( _
                _pagesettings.Margins.Right / 10, 2).ToString
            txtMarginTop.Text = Math.Round( _
                _pagesettings.Margins.Top / 10, 2).ToString
            txtMarginBottom.Text = Math.Round( _
                _pagesettings.Margins.Bottom / 10, 2).ToString
        End If
        pnlPreview.ResumeLayout()
    End Sub

    Private Function PaperSizeFromName(ByVal Name As String) _
            As Printing.PaperSize
        For Each ps As Printing.PaperSize In _printersettings.PaperSizes
            If ps.PaperName = Name Then
                Return ps
            End If
        Next
        Return Nothing
    End Function

    Private Function PaperSourceFromName(ByVal Name As String) _
            As Printing.PaperSource
        For Each ps As Printing.PaperSource In _printersettings.PaperSources
            If ps.SourceName = Name Then
                Return ps
            End If
        Next
        Return Nothing
    End Function

    Private Sub CreateNewPagesettings()
        _pagesettings = New MyPageSettings
        _pagesettings.PrinterSettings = _printersettings
        Dim tmp As Single = 0.0
        If Globalization.RegionInfo.CurrentRegion.IsMetric And _EnableMetric Then
            Single.TryParse(txtMarginLeft.Text.Trim, tmp)
            _pagesettings.Margins.LeftMetric = CSng(Math.Round(tmp * 10, 2))
            Single.TryParse(txtMarginRight.Text.Trim, tmp)
            _pagesettings.Margins.RightMetric = CSng(Math.Round(tmp * 10, 2))
            Single.TryParse(txtMarginTop.Text.Trim, tmp)
            _pagesettings.Margins.TopMetric = CSng(Math.Round(tmp * 10, 2))
            Single.TryParse(txtMarginBottom.Text.Trim, tmp)
            _pagesettings.Margins.BottomMetric = CSng(Math.Round(tmp * 10, 2))
        Else
            Single.TryParse(txtMarginLeft.Text.Trim, tmp)
            _pagesettings.Margins.Left = CSng(Math.Round(tmp * 10, 2))
            Single.TryParse(txtMarginRight.Text.Trim, tmp)
            _pagesettings.Margins.Right = CSng(Math.Round(tmp * 10, 2))
            Single.TryParse(txtMarginTop.Text.Trim, tmp)
            _pagesettings.Margins.Top = CSng(Math.Round(tmp * 10, 2))
            Single.TryParse(txtMarginBottom.Text.Trim, tmp)
            _pagesettings.Margins.Bottom = CSng(Math.Round(tmp * 10, 2))
        End If
        _pagesettings.Landscape = rbtLandscape.Checked
        If cbxPaperSource.Enabled Then
            _pagesettings.PaperSource = _
                PaperSourceFromName(cbxPaperSource.SelectedItem.ToString)
        Else
            _pagesettings.PaperSource = Nothing
        End If
        _pagesettings.PaperSize = _
            PaperSizeFromName(cbxPaperSize.SelectedItem.ToString)
    End Sub

    Private Sub dlgMyPageSetupDialog_Load(ByVal sender As Object, _
                                          ByVal e As System.EventArgs) _
                                      Handles Me.Load
        ShowPageSettings()
    End Sub

    Private Sub pnlPreview_Paint(ByVal sender As Object, _
            ByVal e As System.Windows.Forms.PaintEventArgs) _
            Handles pnlPreview.Paint

        Dim docrect As Rectangle = TransformInchToDevice(e.Graphics, _
                                                         _pagesettings.Bounds)
        Dim marrect As Rectangle = TransformInchToDevice(e.Graphics, _
                                                         _pagesettings.Margins)
        Dim fkt As Double
        If _pagesettings.Landscape Then
            fkt = docrect.Width / (pnlPreview.Width - 10)
        Else
            fkt = docrect.Height / (pnlPreview.Height - 10)
        End If
        docrect.Width = CInt(Math.Round(docrect.Width / fkt))
        docrect.Height = CInt(Math.Round(docrect.Height / fkt))
        marrect.X = CInt(Math.Round(marrect.X / fkt))
        marrect.Y = CInt(Math.Round(marrect.Y / fkt))
        marrect.Width = CInt(Math.Round(marrect.Width / fkt))
        marrect.Height = CInt(Math.Round(marrect.Height / fkt))
        Dim offset As Size = New Size(8, 8)
        If _pagesettings.Landscape Then
            docrect.Location = New Point(0, _
                CInt((pnlPreview.Height - 8 - docrect.Height) / 2) - 3)
        Else
            docrect.Location = New Point( _
                CInt((pnlPreview.Width - 8 - docrect.Width) / 2) - 3, 0)
        End If
        marrect.Size = New Size(docrect.Width - marrect.X - marrect.Width, _
                                docrect.Height - marrect.Y - marrect.Height)
        marrect.Location = New Point(marrect.X + docrect.X, _
                                     marrect.Y + docrect.Y)
        Dim br As Brush = New SolidBrush(SystemColors.ButtonShadow)
        e.Graphics.FillRectangle(br, _
            New Rectangle(docrect.Location + offset, docrect.Size))
        br = New SolidBrush(Color.White)
        e.Graphics.FillRectangle(br, docrect)
        Dim pn As New Pen(Color.Black)
        e.Graphics.DrawRectangle(pn, docrect)
        pn = New Pen(Color.Silver)
        pn.DashStyle = Drawing2D.DashStyle.Dash
        e.Graphics.DrawRectangle(pn, marrect)
        marrect.Location = marrect.Location + New Size(1, 1)
        marrect.Size = marrect.Size - New Size(2, 2)
        Dim ptxt As String = _PreviewText & _PreviewText & _PreviewText & _
            _PreviewText & _PreviewText & _PreviewText & _
            _PreviewText & _PreviewText & _PreviewText
        e.Graphics.DrawString(ptxt, New Font(New FontFamily("Arial"), 3), _
                              New SolidBrush(Color.Black), marrect)
    End Sub

    Private Function TransformInchToDevice(ByVal gr As Graphics, _
                                           ByVal value As PointF) As Point
        Dim pt() As PointF = {value}
        gr.PageUnit = GraphicsUnit.Inch
        gr.TransformPoints(Drawing2D.CoordinateSpace.Device, _
                           Drawing2D.CoordinateSpace.Page, pt)
        Return New Point(CInt(Math.Round(pt(0).X)), CInt(Math.Round(pt(0).Y)))
    End Function

    Private Function TransformInchToDevice(ByVal gr As Graphics, _
            ByVal value As RectangleF) As Rectangle

        Dim pt() As PointF = { _
            New PointF(value.Location.X / 100, value.Location.Y / 100), _
            New PointF(value.Size.Width / 100, value.Size.Height / 100)}
        gr.PageUnit = GraphicsUnit.Inch
        gr.TransformPoints(Drawing2D.CoordinateSpace.Device, _
                           Drawing2D.CoordinateSpace.Page, pt)
        gr.PageUnit = GraphicsUnit.Pixel
        Return New Rectangle(CInt(Math.Round(pt(0).X)), _
                             CInt(Math.Round(pt(0).Y)), _
                             CInt(Math.Round(pt(1).X)), _
                             CInt(Math.Round(pt(1).Y)))
    End Function

    Private Function TransformInchToDevice(ByVal gr As Graphics, _
            ByVal value As MyMargins) As Rectangle

        Dim pt() As PointF = {New PointF(value.Left / 100, value.Top / 100), _
                              New PointF(value.Right / 100, value.Bottom / 100)}
        gr.PageUnit = GraphicsUnit.Inch
        gr.TransformPoints(Drawing2D.CoordinateSpace.Device, _
                           Drawing2D.CoordinateSpace.Page, pt)
        gr.PageUnit = GraphicsUnit.Pixel
        Return New Rectangle(CInt(Math.Round(pt(0).X)), _
                             CInt(Math.Round(pt(0).Y)), _
                             CInt(Math.Round(pt(1).X)), _
                             CInt(Math.Round(pt(1).Y)))
    End Function

    Private Sub cbxPaperSize_SelectedIndexChanged(ByVal sender As Object, _
            ByVal e As System.EventArgs) _
        Handles cbxPaperSize.SelectedIndexChanged

        _pagesettings.PaperSize = _
            PaperSizeFromName(cbxPaperSize.SelectedItem.ToString)
        pnlPreview.Invalidate()
    End Sub

    Private Sub rbtLandscape_CheckedChanged(ByVal sender As Object, _
            ByVal e As System.EventArgs) Handles rbtLandscape.CheckedChanged

        _pagesettings.Landscape = rbtLandscape.Checked
        pnlPreview.Invalidate()
    End Sub

    Private Sub txtMarginBottom_TextChanged(ByVal sender As Object, _
            ByVal e As System.EventArgs) Handles txtMarginBottom.TextChanged

        Dim tmp As Single
        Single.TryParse(txtMarginBottom.Text.Trim, tmp)
        If Globalization.RegionInfo.CurrentRegion.IsMetric And _EnableMetric Then
            _pagesettings.Margins.BottomMetric = CSng(Math.Round(tmp * 10, 2))
        Else
            _pagesettings.Margins.Bottom = CSng(Math.Round(tmp * 10, 2))
        End If
        pnlPreview.Invalidate()
    End Sub

    Private Sub txtMarginLeft_TextChanged(ByVal sender As Object, _
            ByVal e As System.EventArgs) Handles txtMarginLeft.TextChanged

        Dim tmp As Single
        Single.TryParse(txtMarginLeft.Text.Trim, tmp)
        If Globalization.RegionInfo.CurrentRegion.IsMetric And _EnableMetric Then
            _pagesettings.Margins.LeftMetric = CSng(Math.Round(tmp * 10, 2))
        Else
            _pagesettings.Margins.Left = CSng(Math.Round(tmp * 10, 2))
        End If
        pnlPreview.Invalidate()
    End Sub

    Private Sub txtMarginRight_TextChanged(ByVal sender As Object, _
            ByVal e As System.EventArgs) Handles txtMarginRight.TextChanged

        Dim tmp As Single
        Single.TryParse(txtMarginRight.Text.Trim, tmp)
        If Globalization.RegionInfo.CurrentRegion.IsMetric And _EnableMetric Then
            _pagesettings.Margins.RightMetric = CSng(Math.Round(tmp * 10, 2))
        Else
            _pagesettings.Margins.Right = CSng(Math.Round(tmp * 10, 2))
        End If
        pnlPreview.Invalidate()
    End Sub

    Private Sub txtMarginTop_TextChanged(ByVal sender As Object, _
            ByVal e As System.EventArgs) Handles txtMarginTop.TextChanged

        Dim tmp As Single
        Single.TryParse(txtMarginTop.Text.Trim, tmp)
        If Globalization.RegionInfo.CurrentRegion.IsMetric And _EnableMetric Then
            _pagesettings.Margins.TopMetric = CSng(Math.Round(tmp * 10, 2))
        Else
            _pagesettings.Margins.Top = CSng(Math.Round(tmp * 10, 2))
        End If
        pnlPreview.Invalidate()
    End Sub
End Class
